Template = {}

Template['string'] = <<'EOS'
static VALUE
set_<NAME>(VALUE self, VALUE v)
{
    rbCurl *s;
    char   *src, *dst;
    int    len;
    Data_Get_Struct(self, rbCurl, s);
    rb_iv_set(self, "@<NAME>", v);

    if (v != Qnil) {
      src = rb_str2cstr(v, &len);   /* copy string */
      dst = ALLOC_N(char, len+1);   /* able to free */
      memcpy(dst, src, len);
      dst[len] = '\0';
    } else {
      dst = NULL;
    }

    curl_easy_setopt(s->curl, <ID>, dst);
    return Qnil;
}

EOS

Template['string_postfields'] = <<'EOS'
static VALUE
set_<NAME>(VALUE self, VALUE v)
{
    rbCurl *s;
    char   *src, *dst;
    int    len;
    Data_Get_Struct(self, rbCurl, s);
    rb_iv_set(self, "@<NAME>", v);

    if (v != Qnil) {
      src = rb_str2cstr(v, &len);   /* copy string */
      dst = ALLOC_N(char, len);   /* able to free */
      memcpy(dst, src, len);
      curl_easy_setopt(s->curl, CURLOPT_POSTFIELDSIZE, len);
    } else {
      dst = NULL;
    }
    curl_easy_setopt(s->curl, <ID>, dst);

    return Qnil;
}

EOS

Template['long'] = <<'EOS'
static VALUE
set_<NAME>(VALUE self, VALUE v)
{
    rbCurl *s;
    Data_Get_Struct(self, rbCurl, s);
    if (TYPE(v) != T_FIXNUM) { rb_raise(rb_eArgError, "must be Fixnum"); }
    rb_iv_set(self, "@<NAME>", v);
    curl_easy_setopt(s->curl, <ID>, FIX2LONG(v));
    return Qnil;
}

EOS

Template['bool'] = <<'EOS'
static VALUE
set_<NAME>(VALUE self, VALUE v)
{
    rbCurl *s;
    Data_Get_Struct(self, rbCurl, s);
    rb_iv_set(self, "@<NAME>", v);

    switch (v) {
    case Qtrue:  { curl_easy_setopt(s->curl, <ID>, TRUE); break; }
    case Qfalse: { curl_easy_setopt(s->curl, <ID>, FALSE); break; }
    default:	 { rb_raise(rb_eArgError, "must be true or false"); }
    }
    return Qnil;
}

EOS

Template['list'] = <<'EOS'
static VALUE
set_<NAME>(VALUE self, VALUE v)
{
    rbCurl *s;
    int i;
    Data_Get_Struct(self, rbCurl, s);
    rb_iv_set(self, "@<NAME>", v);

    if (s->list_<NAME>) {
        curl_slist_free_all(s->list_<NAME>);
	s->list_<NAME> = NULL;
    }
    if (v != Qnil) {
        for (i = 0; i < RARRAY(v)->len; i++) {
            s->list_<NAME> = curl_slist_append(s->list_<NAME>, rb_str2cstr(RARRAY(v)->ptr[i], 0));
        }
    }

    curl_easy_setopt(s->curl, <ID>, s->list_<NAME>);
    return Qnil;
}

EOS

